#include <Agents/Agent.hpp>
#include <Environment/PictureEnvironment.hpp>

Agent::Agent()
{
}

Agent::Agent(PictureEnvironment* iEnvironment)
{
	//uint32_t WHITE = 0xFFFFFFFF;
	fEnvironment = iEnvironment;

	//fColor = sf::Color(rand() % 0xFFFFFFFFFFFF);
	uint32_t vRand = (((double)rand() / RAND_MAX) * 0xFFFFFFFFU);

	fColor = sf::Color(vRand);
	//fColor = sf::Color(((rand() % fColor.Red.toInteger())));
	fXPos = iEnvironment->getWidth() / 2;
	fYPos = iEnvironment->getHeight() / 2;
}

void Agent::loop()
{
	fEnvironment->getPerception(fXPos, fYPos);
	move();
}

int MOVESIZE = 5;

void Agent::move()
{
	fXPos += (fXPos > MOVESIZE) ? (rand() % MOVESIZE) - (MOVESIZE / 2) : MOVESIZE;
	fYPos += (fYPos > MOVESIZE) ? (rand() % MOVESIZE) - (MOVESIZE / 2) : MOVESIZE;
	fEnvironment->paint(fXPos, fYPos, fColor);
}
